/* This file was generated by scramble.py. */
#line 1 "src/game.py"
#ifndef _GAME_
#define _GAME_
typedef struct Game Game;
#line 1
#include "main.h"
#include "land/obj/obj.h"
#include "dungeon.h"
#include "render.h"
#include "menu.h"
#include "test.h"
#include "names.h"
#line 9
struct Game {
    int level;
    int level_unlocked;
    int level_visited;
    Dungeon * dungeon;
    Dungeon * levels [1 + 9];
    LandArray * kinds;
    LandHash * model_by_name;
    LandArray * kind_by_id;
    LandArray * objects;
    LandArray * moving;
    LandArray * particles;
    int start_t;
    uint64_t t;
#line 24
    int gold;
    int used [3];
    int used_stats [3] [100];
#line 28
    Kind * wall_hidden;
    Kind * ground [5];
    Kind * wall;
    Kind * wall2;
    Kind * wall3;
    Kind * wall4;
    Kind * wall5;
    Kind * wall_torch;
    Kind * vendor_head;
    Kind * vendor_potion;
    Kind * vendor_shield;
    Kind * vendor_smith;
    Kind * quest1;
    Kind * quest2;
    Kind * quest3;
    Kind * quest4;
    Kind * trap_box;
    Kind * trap_fire;
    Kind * trap_poison;
    Kind * trap_lightning;
    Kind * chest;
#line 50
    Kind * knight;
    Kind * rat;
    Kind * troll;
    Kind * troll2;
    Kind * archer;
    Kind * elf;
    Kind * priest;
    Kind * mage;
    Kind * dragon;
#line 60
    Kind * arrow;
    Kind * potion_hp;
    Kind * potion_mp;
    Kind * potion_res;
    Kind * fireball;
    Kind * missile;
#line 67
    Kind * helmet;
    Kind * sword;
    Kind * shield;
    Kind * bow;
    Kind * quiver;
    Kind * book;
    Kind * wand;
    Kind * helmet2;
    Kind * hat;
#line 77
    bool paused;
    bool speed;
    bool title;
    int selx, sely;
    int hover_x, hover_y;
    int hover_cid;
    float mx, my;
    uint64_t bill_due_t;
    int owed;
    bool show_bill;
    bool have_bill;
    bool welcome;
    bool over;
#line 91
    int cheat_timeout_t;
    int cheat_pos;
    char cheat [100];
};
extern int debug_grid;
extern int debug_dungeon;
extern int debug_no_models;
extern int debug_bill;
extern int debug_no_restrict;
#line 101
extern Game * game;
#line 104
Game* game_global(void);
#line 107
void game_new(void);
#line 115
void game_reset(void);
#line 230
char* kind_create_name(Kind * k);
#line 243
void game_change_level(int d);
#line 260
void game_music_volume(int v);
#line 268
void game_init(void);
#line 387
void cheat_health(void);
#line 396
void cheat_equip(void);
#line 412
void cheat(void);
#line 430
void game_tick(void);
#line 551
void particle_tick(Object * ob);
#line 578
void game_draw(void);
#line 651
void game_done(void);
#line 654
void game_place_selected_kind(int kid);
#line 659
void game_spawn_selected_monster(Kind * k);
#line 663
Creature* game_spawn_hero(Dungeon * dungeon, Kind * k, bool spawn);
#line 669
void game_buy(Kind * k, int x, int y);
#line 674
void game_use(Kind * k, int x, int y);
#line 677
void game_projectile(Kind * k, int c1, int c2);
#line 684
void game_unlock_level(void);
#line 690
bool game_reset_used(int uid);
#line 700
void game_pay_bills(void);
#line 709
int game_outstanding(void);
#endif
/* This file was generated by scramble.py. */
